/// @addtogroup homologicalAlgebra
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file homologicalAlgebra.h
///
/// @author Marian Mrozek
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2006 by the CAPD Group.
//
// This file constitutes a part of the CAPD library, 
// distributed under the terms of the GNU General Public License.
// Consult  http://capd.wsb-nlu.edu.pl/ for details. 

#include <iostream>
#include <map>
#include <vector>
#include <set>
#include <iterator>
#include <sstream>

#include "matrixAlgorithms/intMatrixAlgorithms.hpp"
#include "repSet/elementaryCube.h"
#include "repSet/elementaryCell.h"
#include "repSet/RepSet.h"
using namespace capd::matrixAlgorithms;

#include "homologicalAlgebra/FreeModule.h"
#include "homologicalAlgebra/ChainAux.h"
#include "homologicalAlgebra/SubModule.h"
#include "homologicalAlgebra/QuotientModule.h"
#include "homologicalAlgebra/FreeModuleHomomorphism.h"
#include "homologicalAlgebra/FreeChainComplex.h"
#include "homologicalAlgebra/QuotientGradedModule.h"
#include "homologicalAlgebra/ReducibleFreeChainComplex.h"
//#include "homologicalAlgebra/ReducibleFreeChainComplex.hpp"











/// @}

