/// @addtogroup map
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file CnCoeff.cpp
///
/// @author Daniel Wilczak
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2005 by the CAPD Group.
//
// This file constitutes a part of the CAPD library, 
// distributed under the terms of the GNU General Public License.
// Consult  http://capd.wsb-nlu.edu.pl/ for details. 

#include "map/CnCoeff.hpp"
#include "interval/doubleInterval.h"
#include "vectalg/Vector.hpp"
#include "vectalg/Matrix.hpp"
#include "vectalg/dimension.h"

template class capd::map::CnContainer<double>;
template class capd::map::CnContainer<interval>;

template class capd::map::CnCoeff< capd::vectalg::Matrix<double,0,0> >;
template class capd::map::CnCoeff< capd::vectalg::Matrix<interval,0,0> >;

template class capd::map::CnCoeff< capd::vectalg::Matrix<double,DIM,DIM> >;
template class capd::map::CnCoeff< capd::vectalg::Matrix<interval,DIM,DIM> >;

/// @}
