/// @addtogroup vectalg
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file DVectorMD.cpp
///
/// @author The CAPD Group
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2005 by the CAPD Group.
//
// This file constitutes a part of the CAPD library, 
// distributed under the terms of the GNU General Public License.
// Consult  http://capd.wsb-nlu.edu.pl/ for details. 

#include <iostream>
#include "vectalg/Vector.hpp"

using namespace capd::vectalg;

template class Vector<double,0>;

template Vector<double,0> abs<double> (const Vector<double,0> &v);
template Vector<double,0> operator- <double> (const Vector<double,0> &v);
template Vector<double,0> operator+ <double> (const Vector<double,0> &v1,const Vector<double,0> &v2);
template Vector<double,0> operator- <double> (const Vector<double,0> &v1,const Vector<double,0> &v2);
template double operator* <double> (const Vector<double,0> &v1,const Vector<double,0> &v2);

template Vector<double,0> operator* <double,double> (const Vector<double,0> &v,const double &s);
template Vector<double,0> operator* <double,double> (const double &s,const Vector<double,0> &v);
template Vector<double,0> operator/ <double,double> (const Vector<double,0> &v, const double &s);

template Vector<double,0> operator* <double,long>(const Vector<double,0> &v,const long &s);
template Vector<double,0> operator* <double,long>(const long &s,const Vector<double,0> &v);
template Vector<double,0> operator/ <double,long>(const Vector<double,0> &v, const long &s);

template Vector<double,0> operator* <double,int>(const Vector<double,0> &v,const int &s);
template Vector<double,0> operator* <double,int>(const int &s,const Vector<double,0> &v);
template Vector<double,0> operator/ <double,int>(const Vector<double,0> &v, const int &s);

template Vector<double,0> operator+ <double> (const Vector<double,0> &v,const double &s);
template Vector<double,0> operator- <double> (const Vector<double,0> &v,const double &s);
template bool operator < <double> (const Vector<double,0> &v1,const Vector<double,0> &v2);
template bool operator > <double> (const Vector<double,0> &v1,const Vector<double,0> &v2);
template bool operator<= <double> (const Vector<double,0> &v1,const Vector<double,0> &v2);
template bool operator>= <double> (const Vector<double,0> &v1,const Vector<double,0> &v2);
template std::ostream &operator<< <double> (std::ostream &out, const Vector<double,0> &v);
template std::istream &operator>> <double>(std::istream &inp, Vector<double,0> &v);

/// @}
